<?php
if (!isset($sshfed_folder)) {
	require_once("../../../config.php");
}
require_once($sshfed_folder."/api/Auth.php");
require_once($sSp_module_config["path"]."/_include.php");

class sSpAuth implements Auth {
	private $mode;
	private $userData;
	private $config_sSp;
	private $session_sSp;

	public function __construct() {
		GLOBAL $sSp_module_config;
		$this->mode = $sSp_module_config["mode"];
		$this->config_sSp = SimpleSAML_Configuration::getInstance();
		$this->session_sSp = SimpleSAML_Session::getInstance();
		$this->userData = array();
	}

	public function doAuth() {
		if (!$this->session_sSp->isValid($this->mode) ) {
			SimpleSAML_Utilities::redirect(
				'/' . $this->config_sSp->getBaseURL() . $this->mode . '/sp/initSSO.php',
				array('RelayState' => SimpleSAML_Utilities::selfURL())
			);
		}
		
		$this->userData = $this->session_sSp->getAttributes();
		
		return true;
	}
	
	public function getUser() {
		GLOBAL $user_id_attribute;
		
		if (is_array($this->userData[$user_id_attribute])) {
			return $this->userData[$user_id_attribute][0];
		}
		else {
			return $this->userData[$user_id_attribute];
		}
	}
	
	public function getAttributes() {
		return $this->userData;
	}
	
	public function doLogout() {
	}
}

?>