<?php
require_once("../config.php");
require_once($sshfed_folder."/keyManager.php");
require_once($sshfed_folder."/api/Key.php");
require_once($sshfed_folder."/api/Auth.php");
require_once($sshfed_folder."/api/AuthManager.php");

$auth = AuthManager::getAuth($auth_module);
if ($auth->doAuth()==false) {
	die("Authentication failed");
}

if (array_key_exists("nameaction",$_REQUEST)) {
	if (array_key_exists("keyinfo",$_REQUEST)&&strcmp($_REQUEST["nameaction"],"addkey")==0) {
		$certificate = trim($_REQUEST["keyinfo"]);
		$certificate = str_replace("\r","",$certificate);
		$certificate = str_replace("\n","",$certificate);
		$dataCertificate = explode(" ",$certificate);
		if (count($dataCertificate)<3||strcmp($dataCertificate[2],"")==0) {
			$dataCertificate[2]="Added at ".date("m/d/y");
		}
		$key = new Key($dataCertificate[0],$dataCertificate[1],$dataCertificate[2]);
		addKey($auth, $key);
	}
	else if (array_key_exists("idkey",$_REQUEST)&&strcmp($_REQUEST["nameaction"],"delkey")==0) {
		$idKey = $_REQUEST["idkey"];
		delKey($idKey);
	}
}
?>
<html>
	<head>
		<title>Fed.SSH - Keys</title>
		<link rel="stylesheet" type="text/css" media="screen" href="css/style.css" />
		<script type="text/javascript" src="js/prototype-1.6.0.3.js"></script>
		<script type="text/javascript">
	    //<![CDATA[
	    
	    	function cancelKey(idKey) {
	    		document.thehiddenform.idkey.value = $(idKey).innerHTML;
	    		document.thehiddenform.submit();
	    	}
	    
	    //]]>
		</script>
	</head>
	<body>
		<div id="header">
			<div id="logoheader">
				<div id="infouser">
					<div id="datauser"><?php echo $auth->getUser(); ?></div>
					<div id="datakeys"><?php echo count(getUserKeys($auth)); ?> keys</div>
				</div>
				<div id="title">Fed.SSH</div>
				<div id="menu">
					<ul>
						<li><a href="index.php">Home</a></li>
						<li><a href="servers.php">Servers</a></li>
						<li id="selmenu"><a href="keys.php">Keys</a></li>
						<li><a href="help.php">Help</a></li>
					</ul>
				</div>
			</div>
		</div>
		<div id="main">
			<h3>Add a new key</h3>
			<form name="theform" action="keys.php" method="post">
				<input type="hidden" name="nameaction" value="addkey" />
				<div>
					<p>Just copy your public key inside the textbox in order to add a new SSH key. If you don't know how to generate a new one, you can execute the command <strong>ssh-keygen</strong> and copy the content of your files <strong>.ssh/id_dsa.pub</strong> or <strong>.ssh/id_rsa.pub</strong>.</p>
					<div><textarea name="keyinfo" class="keytext"></textarea></div>
					<div style="text-align: center; margin: 12px;"><input type="submit" name="submit" value="Send key" /></div>
				</div>
			</form>
			<h3>List of keys</h3>
			<div id="listkeys">
<?php
if (count(getUserKeys($auth))==0) {
?>
				There isn't any user's key.
<?php
}
else {
?>
			<table id="listkeys" cellspacing="2">
				<thead>
					<tr>
						<td width="25%">Id</td>
						<td width="10%">Algorithm</td>
						<td width="65%">Key</td>
					</tr>
				</thead>
				<tbody>
<?php
	$classname = "rowkey2";
	$index = 0;
	foreach (getUserKeys($auth) as $key) {
		if (strcmp($classname,"rowkey1")==0) {
			$classname = "rowkey2";
		}
		else {
			$classname = "rowkey1";
		}
?>
					<tr class="<?php echo $classname; ?>">
						<td><div id="key-<?php echo $index; ?>"><?php echo $key->getComment(); ?></div><div style="margin-top: 4px;" class="linkButton" onClick="cancelKey('key-<?php echo $index; ?>');">Remove key</div></td>
						<td><?php echo $key->getAlgorithmLabel(); ?></td>
						<td><textarea readonly="true" class="keytext"><?php echo implode("\n",str_split($key->getKey(),80)); ?></textarea></td>
					</tr>
<?php
		$index++;
	}
?>
				</tbody>
			</table>
<?php
}
?>
			<div style="display: none;">
				<form name="thehiddenform" action="keys.php" method="post">
					<input type="hidden" name="nameaction" value="delkey" />
					<input type="hidden" name="idkey" value="" />
				</form>
			</div>
			</div>
		</div>
	</body>
</html>