<?php
require_once("../config.php");
require_once($sshfed_folder."/keyManager.php");
require_once($sshfed_folder."/api/SSHList.php");
require_once($sshfed_folder."/api/SSHServer.php");
require_once($sshfed_folder."/api/Key.php");
require_once($sshfed_folder."/api/Auth.php");
require_once($sshfed_folder."/api/AuthManager.php");

$list = SSHList::readFromConfigFile();

$auth = AuthManager::getAuth($auth_module);
if ($auth->doAuth()==false) {
	die("Authentication failed");
}

function addRowStatus($rowId) {
	echo '<div class="rowdata" id="status-'.$rowId.'">&nbsp;</div>';
}

function addRowResponse($rowId) {
	echo '<div class="rowdata" id="response-'.$rowId.'" style="display: none;">&nbsp;</div>';
}

function addRowQuestionRequestLogin($rowId,$user,$serverId,$numkeys,$policy) {
	GLOBAL $auth;
	
	echo '<div class="rowdata" id="question-'.$rowId.'" style="display: none;">';
	if ($policy->checkPolicy($auth->getAttributes())==true) {
		if ($numkeys>0) {
			echo '	<div><span class="link" onClick="showQuestion(\''.$user.'\',\''.$serverId.'\',false);">Send</span> key for user <span style="font-weight: bold;">'.$user.'</span></div>';
		}
		else {
			echo '	<div><a href="keys.php">Add</a> a key for request a SSH access</div>';
		}
	}
	else {
			echo '	<div>You\'re not allowed to log in as user <strong>'.$user.'</strong></div>';
	}
	echo '</div>';
}

function addRowQuestionChooseKey($rowId,$style,$user,$keys,$serverAddress,$serverId) {
	echo '<div class="rowdata '.$style.'" id="question2-'.$rowId.'" style="display: none;">';
	echo '	<div class="question">Requesting login as '.$user.'</div>';
	echo '	<div class="spacebottom">Choose key:&nbsp;<select id="selKeyServer">';
	foreach ($keys as $key) {
		echo '	<option value="'.$key->getAlgorithm()." ".$key->getKey().'">'.$key->getAlgorithm()." ".$key->getComment().'</option>';
	}
	echo '	</select></div>';
	echo '	<div class="spacebottom">';
	echo '		<span class="linkButton" onClick="sendKey(\''.$serverAddress.'\',\''.$user.'\',\'selKeyServer\',\''.$serverId.'\');">Accept</span>';
	echo '		<span class="linkButton" onClick="showQuestion(\''.$user.'\',\''.$serverId.'\',true);">Cancel</span>';
	echo '	</div>';
	echo '</div>';
}

function addRowQuestionRenewKey($rowId,$style,$user,$serverAddress,$serverId) {
	echo '<div class="rowdata '.$style.'" id="question3-'.$rowId.'" style="display: none;">';
	echo '	<div class="question">Renew login as '.$user.'</div>';
	echo '	<div class="spacebottom" id="question3-until-'.$rowId.'">&nbsp;</div>';
	echo '	<div class="spacebottom">Using key:&nbsp;<span id="question3-key-'.$rowId.'">&nbsp;</span></div>';
	echo '	<div class="spacebottom">';
	echo '		<span class="linkButton" onClick="sendRenewKey(\''.$serverAddress.'\',\''.$user.'\',\''.$serverId.'\');">Accept</span>';
	echo '		<span class="linkButton" onClick="cancelQuestionRenew(\''.$user.'\',\''.$serverAddress.'\',true);">Cancel</span>';
	echo '	</div>';
	echo '</div>';
}

function addRowQuestionResponse($rowId,$style,$user,$serverAddress,$serverId) {
	echo '<div class="rowdata '.$style.'" id="question-response-'.$rowId.'" style="display: none;">';
	echo '	<div class="spacebottom" id="msg-question-response-'.$rowId.'">&nbsp;</div>';
	echo '	<div class="spacebottom">';
	echo '		<span class="linkButton" onClick=\'$("question-response-'.$rowId.'").hide(); checkAccess("'.$serverAddress.'","'.$user.'","'.$serverId.'");\'>Accept</span>';
	echo '	</div>';
	echo '</div>';
}

function addRowQuestionCancelKey($rowId,$style,$user,$serverAddress,$serverId) {
	echo '<div class="rowdata '.$style.'" id="question4-'.$rowId.'" style="display: none;">';
	echo '	<div class="question">Cancel allowed access as '.$user.'</div>';
	echo '	<div class="spacebottom" id="question4-until-'.$rowId.'">&nbsp;</div>';
	echo '	<div class="spacebottom">Using key:&nbsp;<span id="question4-key-'.$rowId.'">&nbsp;</span></div>';
	echo '	<div class="spacebottom">';
	echo '		<span class="linkButton" onClick="sendCancelKey(\''.$serverAddress.'\',\''.$user.'\',\''.$serverId.'\');">Accept</span>';
	echo '		<span class="linkButton" onClick="cancelQuestionCancel(\''.$user.'\',\''.$serverAddress.'\',true);">Cancel</span>';
	echo '	</div>';
	echo '</div>';
}
?>
<html>
	<head>
		<title>Fed.SSH - Home</title>
		<link rel="stylesheet" type="text/css" media="screen" href="css/style.css" />
		<script type="text/javascript">
	    //<![CDATA[
	    
	    	var numKeys = <?php echo count(getUserKeys($auth)); ?>;
	    
	    	function sendKey(server,user,idSel,blockId) {
				var selKey = $(idSel).options[$(idSel).selectedIndex].value;
				var selKeyTemp = selKey.split(" ");
				var alg = selKeyTemp[0];
				var key = selKeyTemp[1];
				
	    		var rowId = user+"-"+blockId; //serverId;
				$("response-"+rowId).update("Sending key...");
				showResponse(user,blockId);
				var cancelIcon = new Element('span', { onClick: 'showQuestion("'+user+'","'+blockId+'",true);' }).update("&nbsp;X");
	    		new Ajax.Request("ws/addkey.php", {
					method: 'post',
					parameters: { oper: "addkey", server: server, user: user, alg: alg, key: key },
					onSuccess: function (response) {
						var xml = response.responseXML;
						var statusList = xml.getElementsByTagName("Status");
						if (statusList.length!=1) {
							$("response-"+rowId).update("Fail").insert(cancelIcon);
						}
						else {
							var status = statusList[0];
							if (status.getAttribute("status")=="success") {
								$("response-"+rowId).update("OK").hide();
								var serverData = server.split(":");
								checkAccess(server,user,blockId);
								checkWebService("ws-"+rowId,server);
							}
							else {
								$("response-"+rowId).update("User "+user+": "+status.getAttribute("msg")).insert(cancelIcon);
							}
						}
					},
					onFailure: function (response) {
						$("response-"+rowId).update("Fail").insert(cancelIcon);
					}
				});
	    	}
	    	
	    	function showResponse(user,blockId) {
	    		var index = user+"-"+blockId;
	    		$("question-"+index, "question2-"+index).invoke("hide");
	    		$("response-"+index).show();
	    	}
	    
	    	function showQuestion(user,server,first) {
	    		var index = user+"-"+server;
	    		if (first==true) {
		    		$("question-"+index).show();
		    		$("question2-"+index, "response-"+index).invoke("hide");
	    		}
	    		else {
		    		$("question2-"+index).show();
		    		$("question-"+index, "response-"+index).invoke("hide");
	    		}
	    	}
	    
	    	function checkCron (blockId,value) {
	    		var temp = value.split("/");
				$(blockId).update("<span style='background: url(imgs/clock_12x12.png) no-repeat center left; padding-left: 16px;'>"+temp[0]+"'</span>");
	    	}
	    	
	    	function checkPatch (blockId) {
				$(blockId).update("<span style='background: url(imgs/terminal_12x12.png) no-repeat center left; padding-left: 16px;'>Patched</span>");
	    	}
	    	
	    	function checkWebService (webServiceId,serverAddress) {
	    		new Ajax.Request("ws/addkey.php", {
					method: 'post',
					parameters: { oper: "checkws", server: serverAddress },
					onSuccess: function (response) {
						var xml = response.responseXML;
						var statusList = xml.getElementsByTagName("Status");
						if (statusList.length!=1) {
							$(webServiceId).update("<span style='background: url(imgs/webpres_12x12.png) no-repeat center left; padding-left: 16px;'>Fail</span>");
						}
						else {
							var status = statusList[0];
							if (status.getAttribute("status")=="success") {
								var groups = xml.getElementsByTagName("SSHGroup");
								if (groups.length==1) {
									var total = parseInt(groups[0].getAttribute("total"));
									var bad = parseInt(groups[0].getAttribute("bad"));
									var good = parseInt(groups[0].getAttribute("good"));
									good = total - bad;
									$(webServiceId).update("<span style='background: url(imgs/greenled_12x12.png) no-repeat center left; padding-left: 16px;'>"+good+"</span><br /><span style='background: url(imgs/redled_12x12.png) no-repeat center left; padding-left: 16px;'>"+bad+"</span>");
									var servers = groups[0].getElementsByTagName("SSHServer");
									for (var i=0; i<servers.length; i++) {
										var host = servers[i].getAttribute("host");
										var port = servers[i].getAttribute("port");
										var result = servers[i].getAttribute("check");
										var mode = servers[i].getAttribute("mode");
										if (mode=="ws") {
											$("ws-"+host+"."+port).update(result);
										}
										else if (mode=="cron") {
											checkCron("ws-"+host+"."+port,result);
										}
										else {
											checkPatch("ws-"+host+"."+port);
										}
									}
								}
								else {
									var infoServer = xml.getElementsByTagName("SSHServer");
									if (infoServer.length==1) {
										var server = infoServer[0];
										var msg = "<span style='background: url(imgs/webpres_12x12.png) no-repeat center left; padding-left: 16px;'>OK</span>";
										if (server.hasAttribute("cron")) {
											var cron = server.getAttribute("cron");
											var cronData = cron.split("/");
											msg = msg + "<br /><span style='background: url(imgs/clock_12x12.png) no-repeat center left; padding-left: 16px;'>"+cronData[0]+"'</span>";
										}
										$(webServiceId).update(msg);
									}
									else {
										$(webServiceId).update("<span style='background: url(imgs/webpres_12x12.png) no-repeat center left; padding-left: 16px;'>Fail</span>");
									}
								}
							}
							else {
								$(webServiceId).update("<span style='background: url(imgs/webpres_12x12.png) no-repeat center left; padding-left: 16px;'>Fail</span>");
							}
						}
					},
					onFailure: function (transport) {
						$(webServiceId).update("<span style='background: url(imgs/webpres_12x12.png) no-repeat center left; padding-left: 16px;'>Fail</span>");
					}
				});

	    	}
	    	
	    	function getAccessTime(ts) {
	    		var now = new Date().getTime();
	    		now = Math.floor(now / 1000);
	    		var diff = ts - now;
	    		
	    		return diff;
	    	}
	    	
	    	function getAccessTimeLabel(diff) {
	    		if (diff<1) {
	    			return "1 sec.";
	    		}
	    		else if (diff<(60)) {
	    			return parseInt(diff)+" sec.";
	    		}
	    		else {
	    			return parseInt(diff/60)+" min.";
	    		}
	    	}
	    	
	    	function getDateTimeLabel(diff,seconds) {
	    			var adate = new Date();
	    			adate.setTime(adate.getTime()+(diff*1000));
	    			var hours = adate.getHours();
		    		if (hours<10) {
		    			hours = "0"+hours;
	    			}
	    			var mins = adate.getMinutes();
					if (mins<10) {
						mins = "0"+mins;
					}
					var secs = adate.getSeconds();
					if (secs<10) {
						secs = "0"+secs;
					}
					if (seconds==false) {
						return hours+":"+mins;
					}
					else {
						return hours+":"+mins+":"+secs;
					}
	    	}
	    	
	    	function getDateTimeLabel2(diff,seconds,crontime,minFlag) {
	    		var minInt = parseInt(minFlag);
	    		var validMinutes = new Array();
	    		for (var i=minInt; i<60; i+=crontime) {
	    			validMinutes[validMinutes.length] = i;
	    		}
    			var adate = new Date();
    			adate.setTime(adate.getTime()+(diff*1000));
	    		while (true) {
	    			var mins = adate.getMinutes();
	    			if (validMinutes.indexOf(mins)==-1) {
		    			adate.setTime(adate.getTime()+(60*1000));
	    			}
	    			else {
		    			var hours = adate.getHours();
			    		if (hours<10) {
			    			hours = "0"+hours;
	    				}
						if (mins<10) {
							mins = "0"+mins;
						}
						var secs = adate.getSeconds();
						if (secs<10) {
							secs = "0"+secs;
						}
						if (seconds==false) {
							return hours+":"+mins;
						}
						else {
							return hours+":"+mins+":"+secs;
						}
					}
				}
	    	}
	    	
	    	function checkAccess (serverAddress,user,blockId) {
	    		var renew = true;
	    		if (numKeys == 0) {
	    			renew = false;
	    		}
	    		var rowId = user+"-"+blockId;
				$("status-"+rowId).update("Checking access...").show();
				var cancelIcon = new Element('span', { onClick: 'showQuestionCancel("'+user+'","'+blockId+'");' }).update("Cancel").addClassName("linkButton2");
				var renewIcon = new Element('span', { onClick: 'showQuestionRenew("'+user+'","'+blockId+'");' }).update("Renew").addClassName("linkButton2");
	    		new Ajax.Request("ws/addkey.php", {
					method: 'get',
					parameters: { oper: "checkkey", server: serverAddress, user: user },
					onSuccess: function (response) {
						var xml = response.responseXML;
						var statusList = xml.getElementsByTagName("Status");
						if (statusList.length!=1) {
							$("status-"+rowId).update("Fail");
						}
						else {
							var status = statusList[0];
							if (status.getAttribute("status")=="success") {
								var sshInfoList = xml.getElementsByTagName("SSHServer");
								var sshGroupList = xml.getElementsByTagName("SSHGroup");
								if (sshInfoList.length==1) {
									var sshInfo = sshInfoList[0];
									var starttime = 0;
									var startmsg = "";
									var endmsg = "";
									var difftime = getAccessTime(parseInt(sshInfo.getAttribute("validUntil")));
									if (sshInfo.hasAttribute("check")&&sshInfo.getAttribute("check")=="cron") {
										starttime = parseInt(sshInfo.getAttribute("validFrom"));
										var checkValue = sshInfo.getAttribute("checkvalue");
										var checkValueData = checkValue.split("/");
										var crontime = parseInt(checkValueData[0]);
										var rvF = starttime + (60*crontime);
										var whenStart = rvF - ((new Date().getTime())/1000);
										if (whenStart <= 0) {
											starttime = 0;
										}
										else {
											startmsg = "by "+getDateTimeLabel2(whenStart, false, crontime, checkValueData[1])+",";
										}
										endmsg = getDateTimeLabel2(difftime, false, crontime, checkValueData[1]);
									}
									else if (sshInfo.hasAttribute("check")&&sshInfo.getAttribute("check")=="ws") {
										var checkValue = sshInfo.getAttribute("checkvalue");
										if (checkValue.include("+cron=")==true) {
											var checkValueData = checkValue.split("+");
											var checkValueData2 = checkValueData[1].split("=");
											var checkValueData3 = checkValueData2[1].split("/");
											var crontime = parseInt(checkValueData3[0]);
											endmsg = getDateTimeLabel2(difftime, false, crontime, checkValueData3[1]);
										}
										else {
											endmsg = getDateTimeLabel(difftime, true);
										}
									}
									else {
										endmsg = getDateTimeLabel(difftime, true);
									}
									if (difftime <= 0) {
										$("status-"+rowId).setStyle({ display: "none" });
										showQuestion(user,blockId,true); // blockId = server+"."+port
									}
									else {
										var key = sshInfo.getAttribute("key");
										var msgElem = $("status-"+rowId).update("<span style='font-weight: bold;'>"+user+"</span>: "+(starttime==0?"":startmsg+" ")+"access valid until "+endmsg).addClassName("userIcon");
										if (renew==true) {
											msgElem = msgElem.insert(renewIcon);
										}
										msgElem.insert(cancelIcon);
										$("question3-key-"+rowId).update(key.substring(0,10)+" ... "+key.substring(key.length-12,key.length));
										$("question3-until-"+rowId).update("Access valid until "+endmsg);
										$("question4-key-"+rowId).update(key.substring(0,10)+" ... "+key.substring(key.length-12,key.length));
										$("question4-until-"+rowId).update("Access valid until "+endmsg);
									}
								}
								else if (sshGroupList.length==1) {
									var sshInfo = sshGroupList[0];
									var difftime = getAccessTime(parseInt(sshInfo.getAttribute("validUntil")));
									if (difftime <= 0) {
										$("status-"+rowId).setStyle({ display: "none" });
										showQuestion(user,blockId,true); // blockId = server+"."+port
									}
									else {
										var key = sshInfo.getAttribute("key");
										var labeltime = getAccessTimeLabel(difftime);
										var msgElem = $("status-"+rowId).update("User "+user+": access valid until "+labeltime);
										if (renew == true) {
											msgElem = msgElem.insert(renewIcon);
										}
										msgElem.insert(cancelIcon);
										$("question3-key-"+rowId).update(key.substring(0,10)+" ... "+key.substring(key.length-12,key.length));
										$("question3-until-"+rowId).update("Access valid until "+labeltime);
										$("question4-key-"+rowId).update(key.substring(0,10)+" ... "+key.substring(key.length-12,key.length));
										$("question4-until-"+rowId).update("Access valid until "+labeltime);
									}
								}
								else {
									$("status-"+rowId).update("Fail");
								}
							}
							else {
								$("status-"+rowId).update("User "+user+": "+status.getAttribute("msg"));
							}
						}
					},
					onFailure: function (response) {
						$("status-"+rowId).update("Bad response");
					}
				});
	    	}
	    
	    	function showQuestionRenew (user,server) {
	    		var index = user+"-"+server.replace(/:/,".");
	    		$("status-"+index).hide();
	    		$("question3-"+index).show();
	    	}
	    	
	    	function cancelQuestionRenew (user,server) {
	    		var index = user+"-"+server.replace(/:/,".");
	    		$("status-"+index).show();
	    		$("question3-"+index).hide();
	    	}
	    	
	    	function showQuestionCancel (user,server) {
	    		var index = user+"-"+server.replace(/:/,".");
	    		$("status-"+index).hide();
	    		$("question4-"+index).show();
	    	}
	    	
	    	function cancelQuestionCancel (user,server) {
	    		var index = user+"-"+server.replace(/:/,".");
	    		$("status-"+index).show();
	    		$("question4-"+index).hide();
	    	}
	    	
	    	function sendCancelKey (server, user, blockId) {
	    		var rowId = user+"-"+blockId;
				$("response-"+rowId).update("Sending action...");
	    		$("question4-"+rowId).hide();
				showResponse(user,blockId);
	    		new Ajax.Request("ws/addkey.php", {
					method: 'post',
					parameters: { oper: "cancelkey", server: server, user: user },
					onSuccess: function (response) {
						var xml = response.responseXML;
						var statusList = xml.getElementsByTagName("Status");
						if (statusList.length!=1) {
							$("msg-question-response-"+rowId).update("Error canceling access for user "+user);
						}
						else {
							var status = statusList[0];
							if (status.getAttribute("status")=="success") {
								$("msg-question-response-"+rowId).update("Access canceled for user "+user);
								checkWebService("ws-"+rowId,server);
							}
							else {
								$("msg-question-response-"+rowId).update("Error canceling access for user "+user);
							}
						}
						$("response-"+rowId).hide();
						$("question-response-"+rowId).show();
					},
					onFailure: function (response) {
						$("response-"+rowId).hide();
						$("msg-question-response-"+rowId).update("Error canceling access for user "+user);
						$("question-response-"+rowId).show();
					}
				});
	    	}
	    	
	    	function sendRenewKey (server, user, blockId) {
	    		var rowId = user+"-"+blockId;
				$("response-"+rowId).update("Sending action...");
	    		$("question3-"+rowId).hide();
				showResponse(user,blockId);
	    		new Ajax.Request("ws/addkey.php", {
					method: 'post',
					parameters: { oper: "updatekey", server: server, user: user },
					onSuccess: function (response) {
						var xml = response.responseXML;
						var statusList = xml.getElementsByTagName("Status");
						if (statusList.length!=1) {
							$("msg-question-response-"+rowId).update("Error renewing access for user "+user);
						}
						else {
							var status = statusList[0];
							if (status.getAttribute("status")=="success") {
								$("msg-question-response-"+rowId).update("Access renewed for user "+user);
							}
							else {
								$("msg-question-response-"+rowId).update("Error renewing access for user "+user);
							}
						}
						$("response-"+rowId).hide();
						$("question-response-"+rowId).show();
					},
					onFailure: function (response) {
						$("response-"+rowId).hide();
						$("msg-question-response-"+rowId).update("Error renewing access for user "+user);
						$("question-response-"+rowId).show();
					}
				});
	    	}
	    	
	    	function showGroup (group,elemIcon) {
	    		$(elemIcon).toggleClassName("downgroup");
				var rows = $$("tr[group="+group+"]");
				for (var i=0; i<rows.length; i++) {
					$(rows[i]).toggle();
				}
	    	}
	    	
	    	window.onload = function () {
<?php
foreach ($list->getSSHServerList() as $server) {
	$mode = $server->getCheckMode();
	if (strcmp($mode,"ws")==0) {
?>
				checkWebService("ws-<?php echo $server->getHost().".".$server->getPort(); ?>",
						"<?php echo $server->getHost().":".$server->getPort(); ?>");
<?php
	}
	else if (strcmp($mode,"cron")==0) {
?>
				checkCron("ws-<?php echo $server->getHost().".".$server->getPort(); ?>",
						"<?php echo $server->getCheckModeData(); ?>");
<?php
	}
	else {
?>
				checkPatch("ws-<?php echo $server->getHost().".".$server->getPort(); ?>");
<?php
	}
	foreach ($server->getPolicies() as $policy) {
?>
				checkAccess("<?php echo $server->getHost().':'.$server->getPort(); ?>",
						"<?php echo $policy->getUser(); ?>","<?php echo $server->getHost().".".$server->getPort(); ?>");
<?php
	}
}
foreach ($list->getSSHGroupList() as $group) {
?>
				checkWebService("ws-<?php echo $group->getID(); ?>", "group@<?php echo $group->getID(); ?>");
<?php
	foreach ($group->getPolicies() as $policy) {
?>
				checkAccess("group@<?php echo $group->getID(); ?>",
						"<?php echo $policy->getUser(); ?>","<?php echo $group->getID(); ?>");
<?php
	}
}
?>
	    	}
	    //]]>
		</script>
		<script type="text/javascript" src="js/prototype-1.6.0.3.js"></script>
	</head>
	<body>
		<div id="header">
			<div id="logoheader">
				<div id="infouser">
					<div id="datauser"><?php echo $auth->getUser(); ?></div>
					<div id="datakeys"><?php echo count(getUserKeys($auth)); ?> keys</div>
				</div>
				<div id="title">Fed.SSH</div>
				<div id="menu">
					<ul>
						<li><a href="index.php">Home</a></li>
						<li id="selmenu"><a href="servers.php">Servers</a></li>
						<li><a href="keys.php">Keys</a></li>
						<li><a href="help.php">Help</a></li>
					</ul>
				</div>
			</div>
		</div>
		<div id="main">
			<p>&nbsp;</p>
			<table id="listkeys" cellspacing="2">
				<thead>
					<tr>
						<td width="25%">Server</td>
						<td width="15%">Status</td>
						<td width="60%">Available connections</td>
					</tr>
				</thead>
				<tbody>
<?php
$classname = "rowkey2";
foreach ($list->getSSHServerList() as $server) {
	if (strcmp($classname,"rowkey1")==0) {
		$classname = "rowkey2";
	}
	else {
		$classname = "rowkey1";
	}
	$serverId = $server->getHost().".".$server->getPort();
	$serverAddress = $server->getHost().":".$server->getPort();
	$serverAddressLabel = $server->getHost();
	if ($server->getPort()!=22) {
		$serverAddressLabel .= ":".$server->getPort();
	}
?>
					<tr class="<?php echo $classname; ?>">
						<td><?php echo $serverAddressLabel; ?></td>
						<td><span id="ws-<?php echo $serverId; ?>">Checking...</span></td>
						<td>
<?php
	$policies = $server->getPolicies();
	for ($i=0; $i<count($policies); $i++) {
		$style = "middlerow";
		if ($i==0&&count($policies)==1) {
			$style = "";
		}
		else if ($i==(count($policies)-1)) {
			$style = "endrow";
		}
		else if ($i==0) {
			$style = "firstrow";
		}
		$policy = $policies[$i];
		$rowId = $policy->getUser()."-".$serverId;
		
		addRowQuestionRequestLogin($rowId,$policy->getUser(),$serverId,count(getUserKeys($auth)),$policy);
		addRowQuestionChooseKey($rowId,$style,$policy->getUser(),getUserKeys($auth),$serverAddress,$serverId);
		addRowQuestionRenewKey($rowId,$style,$policy->getUser(),$serverAddress,$serverId);
		addRowQuestionResponse($rowId,$style,$policy->getUser(),$serverAddress,$serverId);
		addRowQuestionCancelKey($rowId,$style,$policy->getUser(),$serverAddress,$serverId);
		addRowResponse($rowId);
		addRowStatus($rowId);
	}
?>
						</td>
					</tr>
<?php
}
foreach ($list->getSSHGroupList() as $group) {
	if (strcmp($classname,"rowkey1")==0) {
		$classname = "rowkey2";
	}
	else {
		$classname = "rowkey1";
	}
?>
					<tr class="<?php echo $classname; ?>">
						<td><span class="leftgroup" onClick="showGroup('<?php echo $group->getID(); ?>',this);">&nbsp;</span>Group <?php echo $group->getID(); ?></td>
						<td><span id="ws-<?php echo $group->getID(); ?>">Checking...</span></td>
						<td>
<?php
	$policies = $group->getPolicies();
	for ($i=0; $i<count($policies); $i++) {
		$style = "middlerow";
		if ($i==0&&count($policies)==1) {
			$style = "";
		}
		else if ($i==(count($policies)-1)) {
			$style = "endrow";
		}
		else if ($i==0) {
			$style = "firstrow";
		}
		$policy = $policies[$i];
		$rowId = $policy->getUser()."-".$group->getID();
		
		addRowQuestionRequestLogin($rowId,$policy->getUser(),$group->getID(),count(getUserKeys($auth)),$policy);
		addRowQuestionChooseKey($rowId,$style,$policy->getUser(),getUserKeys($auth),"group@".$group->getID(),$group->getID());
		addRowQuestionRenewKey($rowId,$style,$policy->getUser(),"group@".$group->getID(),$group->getID());
		addRowQuestionResponse($rowId,$style,$policy->getUser(),"group@".$group->getID(),$group->getID());
		addRowQuestionCancelKey($rowId,$style,$policy->getUser(),"group@".$group->getID(),$group->getID());
		addRowResponse($rowId);
		addRowStatus($rowId);
	}
?>
						</td>
					</tr>
<?php
	foreach ($group->getServers() as $server) {
		$serverAddressLabel = $server->getHost();
		if ($server->getPort()!=22) {
			$serverAddressLabel .= $server->getPort();
		}
?>
					<tr group="<?php echo $group->getID(); ?>" style="display: none;" class="<?php echo $classname; ?>">
						<td><span class="serverlistgroup"><?php echo $serverAddressLabel; ?></span></td>
						<td><span id="ws-<?php echo $server->getHost().".".$server->getPort(); ?>">Checking...</span></td>
						<td>&nbsp;</td>
					</tr>
<?php
	}
}
?>
				</tbody>
			</table>
		</div>
	</body>
</html>